#ifndef _PROCINFO_
#define _PROCINFO_

#include <Events.h>
#include <MixedMode.h>
#include <MacTypes.h>


#define RESULT_OFFSET(type)	((sizeof(type) == 1) ? 3 : ((sizeof(type) == 2) ? 1 : 0))

typedef pascal void (*CleanUpApplicationPatchPtr)(void);
typedef pascal void (*CloseWindowProcPtr)(WindowPtr window);
typedef pascal void (*CloseWindowPatchPtr)(WindowPtr window,CloseWindowProcPtr closeWindowProc);
typedef pascal void (*DMFinalInitPatchPtr)(void);
typedef pascal void (*DisposeWindowProcPtr)(WindowPtr window);
typedef pascal void (*DisposeWindowPatchPtr)(WindowPtr window,DisposeWindowProcPtr disposeWindowProc);
typedef pascal SInt32 (*DragGrayRgnLWProcPtr)(RgnHandle rgn,Point start,const Rect *limit,const Rect *slop,SInt16 axis,DragGrayRgnUPP action);
typedef pascal SInt32 (*DragGrayRgnPatchPtr)(RgnHandle rgn,Point start,const Rect *limit,const Rect *slop,SInt16 axis,DragGrayRgnUPP action,DragGrayRgnLWProcPtr dragGrayRgnLWProc);
typedef pascal void (*DragWindowProcPtr)(WindowPtr window,Point start,Rect *limit);
typedef pascal void (*DragWindowPatchPtr)(WindowPtr window,Point start,Rect *limit,DragWindowProcPtr dragWindowProc);
typedef pascal SInt16 (*FindSystemWindowPatchPtr)(Point where,WindowPtr *window,SInt16 result);
typedef pascal SInt16 (*FindWindowProcPtr)(Point where,WindowPtr *window);
typedef pascal SInt16 (*FindWindowPatchPtr)(Point where,WindowPtr *window,FindWindowProcPtr findWindowProc);
typedef pascal void (*FrameRgnProcPtr)(RgnHandle rgn);
typedef pascal void (*FrameRgnPatchPtr)(RgnHandle rgn,FrameRgnProcPtr frameRgnProc);
typedef pascal void (*GetMouseProcPtr)(Point *mouseLoc);
typedef pascal void (*GetMousePatchPtr)(Point *mouseLoc,GetMouseProcPtr getMouseProc);
typedef pascal void (*InitApplicationPatchPtr)(void);
typedef pascal SInt32 (*MenuSelectProcPtr)(Point *startPt);
typedef pascal SInt32 (*MenuSelectPatchPtr)(Point *startPt,MenuSelectProcPtr menuSelectProc);
typedef pascal void (*PaintRgnProcPtr)(RgnHandle rgn);
typedef pascal void (*PaintRgnPatchPtr)(RgnHandle rgn,PaintRgnProcPtr paintRgnProc);
typedef pascal void (*PostEventPatchPtr)(EventKind *num,UInt32 *msg);
typedef pascal Boolean (*StillDownProcPtr)(void);
typedef pascal Boolean (*StillDownPatchPtr)(StillDownProcPtr stillDownProc);
typedef pascal void (*SynchIdleTimePatchPtr)(void);
typedef pascal OSErr (*SysWindowHandlerProcPtr)(WindowPtr window,EventRecord *event,SInt16 part,Boolean *handled);
typedef pascal Boolean (*TrackGoAwayProcPtr)(WindowPtr window,Point where);
typedef pascal Boolean (*TrackGoAwayPatchPtr)(WindowPtr window,Point where,TrackGoAwayProcPtr trackGoAwayProc);
typedef pascal void (*VBLPatchPtr)(void);
typedef pascal Boolean (*WaitMouseUpProcPtr)(void);
typedef pascal Boolean (*WaitMouseUpPatchPtr)(WaitMouseUpProcPtr waitMouseUpProc);
typedef pascal Boolean (*WaitNextEventProcPtr)(EventMask mask,EventRecord *event,UInt32 sleep,RgnHandle mouse);
typedef pascal void (*WaitNextEventPrePatchPtr)(EventMask *mask,EventRecord *event,UInt32 *sleep,RgnHandle *mouse);
typedef pascal Boolean (*WaitNextEventPostPatchPtr)(EventMask *mask,EventRecord *event,UInt32 *sleep,RgnHandle *mouse,Boolean result);

#if GENERATINGCFM
typedef UniversalProcPtr 				CleanUpApplicationPatchUPP;
typedef UniversalProcPtr 				CloseWindowProcUPP;
typedef UniversalProcPtr 				CloseWindowPatchUPP;
typedef UniversalProcPtr 				DMFinalInitPatchUPP;
typedef UniversalProcPtr 				DisposeWindowProcUPP;
typedef UniversalProcPtr 				DisposeWindowPatchUPP;
typedef UniversalProcPtr 				DragGrayRgnLWProcUPP;
typedef UniversalProcPtr 				DragGrayRgnPatchUPP;
typedef UniversalProcPtr 				DragWindowProcUPP;
typedef UniversalProcPtr 				DragWindowPatchUPP;
typedef UniversalProcPtr 				FindSystemWindowPatchUPP;
typedef UniversalProcPtr 				FindWindowProcUPP;
typedef UniversalProcPtr 				FindWindowPatchUPP;
typedef UniversalProcPtr 				FrameRgnProcUPP;
typedef UniversalProcPtr 				FrameRgnPatchUPP;
typedef UniversalProcPtr 				GetMouseProcUPP;
typedef UniversalProcPtr 				GetMousePatchUPP;
typedef UniversalProcPtr 				InitApplicationPatchUPP;
typedef UniversalProcPtr 				MenuSelectProcUPP;
typedef UniversalProcPtr 				MenuSelectPatchUPP;
typedef UniversalProcPtr 				PaintRgnProcUPP;
typedef UniversalProcPtr 				PaintRgnPatchUPP;
typedef UniversalProcPtr 				PostEventPatchUPP;
typedef UniversalProcPtr 				StillDownProcUPP;
typedef UniversalProcPtr 				StillDownPatchUPP;
typedef UniversalProcPtr 				SynchIdleTimePatchUPP;
typedef UniversalProcPtr				SysWindowHandlerUPP;
typedef UniversalProcPtr 				TrackGoAwayProcUPP;
typedef UniversalProcPtr 				TrackGoAwayPatchUPP;
typedef UniversalProcPtr 				VBLPatchUPP;
typedef UniversalProcPtr 				WaitMouseUpProcUPP;
typedef UniversalProcPtr 				WaitMouseUpPatchUPP;
typedef UniversalProcPtr 				WaitNextEventProcUPP;
typedef UniversalProcPtr 				WaitNextEventPrePatchUPP;
typedef UniversalProcPtr 				WaitNextEventPostPatchUPP;
#else
typedef CleanUpApplicationPatchPtr 		CleanUpApplicationPatchUPP;
typedef CloseWindowProcPtr				CloseWindowProcUPP;
typedef CloseWindowPatchPtr				CloseWindowPatchUPP;
typedef DMFinalInitPatchPtr				DMFinalInitPatchUPP;
typedef DisposeWindowProcPtr			DisposeWindowProcUPP;
typedef DisposeWindowPatchPtr			DisposeWindowPatchUPP;
typedef DragGrayRgnLWProcPtr			DragGrayRgnLWProcUPP;
typedef DragGrayRgnPatchPtr				DragGrayRgnPatchUPP;
typedef DragWindowProcPtr				DragWindowProcUPP;
typedef DragWindowPatchPtr				DragWindowPatchUPP;
typedef FindSystemWindowPatchPtr		FindSystemWindowPatchUPP;
typedef FindWindowProcPtr				FindWindowProcUPP;
typedef FindWindowPatchPtr				FindWindowPatchUPP;
typedef FrameRgnProcPtr		 			FrameRgnProcUPP;
typedef FrameRgnPatchPtr		 		FrameRgnPatchUPP;
typedef GetMouseProcPtr		 			GetMouseProcUPP;
typedef GetMousePatchPtr		 		GetMousePatchUPP;
typedef InitApplicationPatchPtr 		InitApplicationPatchUPP;
typedef MenuSelectProcPtr		 		MenuSelectProcUPP;
typedef MenuSelectPatchPtr		 		MenuSelectPatchUPP;
typedef PaintRgnProcPtr		 			PaintRgnProcUPP;
typedef PaintRgnPatchPtr		 		PaintRgnPatchUPP;
typedef PostEventPatchPtr				PostEventPatchUPP;
typedef StillDownProcPtr		 		StillDownProcUPP;
typedef StillDownPatchPtr		 		StillDownPatchUPP;
typedef SynchIdleTimePatchPtr			SynchIdleTimePatchUPP;
typedef SysWindowHandlerProcPtr			SysWindowHandlerUPP;
typedef TrackGoAwayProcPtr		 		TrackGoAwayProcUPP;
typedef TrackGoAwayPatchPtr		 		TrackGoAwayPatchUPP;
typedef VBLPatchPtr		 				VBLPatchUPP;
typedef WaitMouseUpProcPtr		 		WaitMouseUpProcUPP;
typedef WaitMouseUpPatchPtr		 		WaitMouseUpPatchUPP;
typedef WaitNextEventProcPtr			WaitNextEventProcUPP;
typedef WaitNextEventPrePatchPtr		WaitNextEventPrePatchUPP;
typedef WaitNextEventPostPatchPtr		WaitNextEventPostPatchUPP;
#endif

enum {
	uppCleanUpApplicationPatchProcInfo = kPascalStackBased,
	uppCloseWindowProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr))),
	uppCloseWindowPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(CloseWindowProcPtr))),
	uppDMFinalInitPatchProcInfo = kPascalStackBased,
	uppDisposeWindowProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr))),
	uppDisposeWindowPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(DisposeWindowProcPtr))),
	uppDragGrayRgnLWProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt32)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(const Rect*)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(const Rect*)))
		| STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(SInt16)))
		| STACK_ROUTINE_PARAMETER(6,SIZE_CODE(sizeof(DragGrayRgnUPP))),
	uppDragGrayRgnPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt32)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(const Rect*)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(const Rect*)))
		| STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(SInt16)))
		| STACK_ROUTINE_PARAMETER(6,SIZE_CODE(sizeof(DragGrayRgnUPP)))
		| STACK_ROUTINE_PARAMETER(7,SIZE_CODE(sizeof(DragGrayRgnLWProcPtr))),
	uppDragWindowProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(Rect*))),
	uppDragWindowPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(Rect*)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(DragWindowProcPtr))),
	uppFindSystemWindowPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt16)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(WindowPtr*)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(SInt16))),
	uppFindWindowProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt16)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(WindowPtr*))),
	uppFindWindowPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt16)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(WindowPtr*)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(FindWindowProcPtr))),
	uppFrameRgnProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle))),
	uppFrameRgnPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(FrameRgnProcPtr))),
	uppGetMouseProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point*))),
	uppGetMousePatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point*)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(GetMouseProcPtr))),
	uppInitApplicationPatchProcInfo = kPascalStackBased,
	uppMenuSelectProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt32)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point*))),
	uppMenuSelectPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(SInt32)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(Point*)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(MenuSelectProcPtr))),
	uppPaintRgnProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle))),
	uppPaintRgnPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(RgnHandle)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(PaintRgnProcPtr))),
	uppPostEventPatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventKind*)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(UInt32*))),
	uppStillDownProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean))),
	uppStillDownPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(StillDownProcPtr))),
	uppSynchIdleTimePatchProcInfo = kPascalStackBased,
	uppSysWindowHandlerProcInfo = kPascalStackBased
		 | RESULT_SIZE(SIZE_CODE(sizeof(OSErr)))
		 | STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		 | STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		 | STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(SInt16)))
		 | STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(Boolean*))),
	uppTrackGoAwayProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point))),
	uppTrackGoAwayPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WindowPtr)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(TrackGoAwayProcPtr))),
	uppVBLPatchProcInfo = kPascalStackBased,
	uppWaitMouseUpProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean))),
	uppWaitMouseUpPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(WaitMouseUpProcPtr))),
	uppWaitNextEventProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventMask)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(UInt32)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(RgnHandle))),
	uppWaitNextEventPrePatchProcInfo = kPascalStackBased
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventMask*)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(UInt32*)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(RgnHandle*))),
	uppWaitNextEventPostPatchProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(Boolean)))
		| STACK_ROUTINE_PARAMETER(1,SIZE_CODE(sizeof(EventMask*)))
		| STACK_ROUTINE_PARAMETER(2,SIZE_CODE(sizeof(EventRecord*)))
		| STACK_ROUTINE_PARAMETER(3,SIZE_CODE(sizeof(UInt32*)))
		| STACK_ROUTINE_PARAMETER(4,SIZE_CODE(sizeof(RgnHandle*)))
		| STACK_ROUTINE_PARAMETER(5,SIZE_CODE(sizeof(Boolean)))
};

#if GENERATINGCFM
#define NewCleanUpApplicationPatch(userRoutine)		(CleanUpApplicationPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppCleanUpApplicationPatchProcInfo,GetCurrentArchitecture())
#define NewCloseWindowProc(userRoutine)				(CloseWindowProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppCloseWindowProcInfo,GetCurrentArchitecture())
#define NewCloseWindowPatch(userRoutine)			(CloseWindowPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppCloseWindowPatchProcInfo,GetCurrentArchitecture())
#define NewDMFinalInitPatch(userRoutine)			(DMFinalInitPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDMFinalInitPatchProcInfo,GetCurrentArchitecture())
#define NewDisposeWindowProc(userRoutine)			(DisposeWindowProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDisposeWindowProcInfo,GetCurrentArchitecture())
#define NewDisposeWindowPatch(userRoutine)			(DisposeWindowPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDisposeWindowPatchProcInfo,GetCurrentArchitecture())
#define NewDragGrayRgnLWProc(userRoutine)			(DragGrayRgnLWProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDragGrayRgnLWProcInfo,GetCurrentArchitecture())
#define NewDragGrayRgnPatch(userRoutine)			(DragGrayRgnPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDragGrayRgnPatchProcInfo,GetCurrentArchitecture())
#define NewDragWindowProc(userRoutine)				(DragWindowProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDragWindowProcInfo,GetCurrentArchitecture())
#define NewDragWindowPatch(userRoutine)				(DragWindowPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppDragWindowPatchProcInfo,GetCurrentArchitecture())
#define NewFindSystemWindowPatch(userRoutine)		(FindSystemWindowPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFindSystemWindowPatchProcInfo,GetCurrentArchitecture())
#define NewFindWindowProc(userRoutine)				(FindWindowProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFindWindowProcInfo,GetCurrentArchitecture())
#define NewFindWindowPatch(userRoutine)				(FindWindowPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFindWindowPatchProcInfo,GetCurrentArchitecture())
#define NewFrameRgnProc(userRoutine)				(FrameRgnProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFrameRgnProcInfo,GetCurrentArchitecture())
#define NewFrameRgnPatch(userRoutine)				(FrameRgnPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppFrameRgnPatchProcInfo,GetCurrentArchitecture())
#define NewGetMouseProc(userRoutine)				(GetMouseProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppGetMouseProcInfo,GetCurrentArchitecture())
#define NewGetMousePatch(userRoutine)				(GetMousePatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppGetMousePatchProcInfo,GetCurrentArchitecture())
#define NewInitApplicationPatch(userRoutine)		(InitApplicationPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppInitApplicationPatchProcInfo,GetCurrentArchitecture())
#define NewMenuSelectProc(userRoutine)				(MenuSelectProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppMenuSelectProcInfo,GetCurrentArchitecture())
#define NewMenuSelectPatch(userRoutine)				(MenuSelectPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppMenuSelectPatchProcInfo,GetCurrentArchitecture())
#define NewPaintRgnProc(userRoutine)				(PaintRgnProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPaintRgnProcInfo,GetCurrentArchitecture())
#define NewPaintRgnPatch(userRoutine)				(PaintRgnPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPaintRgnPatchProcInfo,GetCurrentArchitecture())
#define NewPostEventPatch(userRoutine)				(PostEventPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppPostEventPatchProcInfo,GetCurrentArchitecture())
#define NewStillDownProc(userRoutine)				(StillDownProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppStillDownProcInfo,GetCurrentArchitecture())
#define NewStillDownPatch(userRoutine)				(StillDownPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppStillDownPatchProcInfo,GetCurrentArchitecture())
#define NewSynchIdleTimePatch(userRoutine)			(SynchIdleTimePatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppSynchIdleTimePatchProcInfo,GetCurrentArchitecture())
#define NewSysWindowHandlerProc(userRoutine)		(SysWindowHandlerUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppSysWindowHandlerProcInfo,GetCurrentArchitecture())
#define NewTrackGoAwayProc(userRoutine)				(TrackGoAwayProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppTrackGoAwayProcInfo,GetCurrentArchitecture())
#define NewTrackGoAwayPatch(userRoutine)			(TrackGoAwayPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppTrackGoAwayPatchProcInfo,GetCurrentArchitecture())
#define NewVBLPatch(userRoutine)					(VBLPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppVBLPatchProcInfo,GetCurrentArchitecture())
#define NewWaitMouseUpProc(userRoutine)				(WaitMouseUpProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitMouseUpProcInfo,GetCurrentArchitecture())
#define NewWaitMouseUpPatch(userRoutine)			(WaitMouseUpPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitMouseUpPatchProcInfo,GetCurrentArchitecture())
#define NewWaitNextEventProc(userRoutine)			(WaitNextEventProcUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitNextEventProcInfo,GetCurrentArchitecture())
#define NewWaitNextEventPrePatch(userRoutine)		(WaitNextEventPrePatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitNextEventPrePatchProcInfo,GetCurrentArchitecture())
#define NewWaitNextEventPostPatch(userRoutine)		(WaitNextEventPostPatchUPP)NewRoutineDescriptor((ProcPtr)(userRoutine),uppWaitNextEventPostPatchProcInfo,GetCurrentArchitecture())
#else
#define NewCleanUpApplicationPatch(userRoutine)		((CleanUpApplicationPatchUPP)(userRoutine))
#define NewCloseWindowProc(userRoutine)				((CloseWindowProcUPP)(userRoutine))
#define NewCloseWindowPatch(userRoutine)			((CloseWindowPatchUPP)(userRoutine))
#define NewDMFinalInitPatch(userRoutine)			((DMFinalInitPatchUPP)(userRoutine))
#define NewDisposeWindowProc(userRoutine)			((DisposeWindowProcUPP)(userRoutine))
#define NewDisposeWindowPatch(userRoutine)			((DisposeWindowPatchUPP)(userRoutine))
#define NewDragGrayRgnLWProc(userRoutine)			((DragGrayRgnLWProcUPP)(userRoutine))
#define NewDragGrayRgnPatch(userRoutine)			((DragGrayRgnPatchUPP)(userRoutine))
#define NewDragWindowProc(userRoutine)				((DragWindowProcUPP)(userRoutine))
#define NewDragWindowPatch(userRoutine)				((DragWindowPatchUPP)(userRoutine))
#define NewFindSystemWindowPatch(userRoutine)		((FindSystemWindowPatchUPP)(userRoutine))
#define NewFindWindowProc(userRoutine)				((FindWindowProcUPP)(userRoutine))
#define NewFindWindowPatch(userRoutine)				((FindWindowPatchUPP)(userRoutine))
#define NewFrameRgnProc(userRoutine)				((FrameRgnProcUPP)(userRoutine))
#define NewFrameRgnPatch(userRoutine)				((FrameRgnPatchUPP)(userRoutine))
#define NewGetMouseProc(userRoutine)				((GetMouseProcUPP)(userRoutine))
#define NewGetMousePatch(userRoutine)				((GetMousePatchUPP)(userRoutine))
#define NewInitApplicationPatch(userRoutine)		((InitApplicationPatchUPP)(userRoutine))
#define NewMenuSelectProc(userRoutine)				((MenuSelectProcUPP)(userRoutine))
#define NewMenuSelectPatch(userRoutine)				((MenuSelectPatchUPP)(userRoutine))
#define NewPaintRgnProc(userRoutine)				((PaintRgnProcUPP)(userRoutine))
#define NewPaintRgnPatch(userRoutine)				((PaintRgnPatchUPP)(userRoutine))
#define NewPostEventPatch(userRoutine)				((PostEventPatchUPP)(userRoutine))
#define NewStillDownProc(userRoutine)				((StillDownProcUPP)(userRoutine))
#define NewStillDownPatch(userRoutine)				((StillDownPatchUPP)(userRoutine))
#define NewSynchIdleTimePatch(userRoutine)			((SynchIdleTimePatchUPP)(userRoutine))
#define NewSysWindowHandlerProc(userRoutine)		((SysWindowHandlerUPP)(userRoutine))
#define NewTrackGoAwayProc(userRoutine)				((TrackGoAwayProcUPP)(userRoutine))
#define NewTrackGoAwayPatch(userRoutine)			((TrackGoAwayPatchUPP)(userRoutine))
#define NewVBLPatch(userRoutine)					((VBLPatchUPP)(userRoutine))
#define NewWaitMouseUpProc(userRoutine)				((WaitMouseUpProcUPP)(userRoutine))
#define NewWaitMouseUpPatch(userRoutine)			((WaitMouseUpPatchUPP)(userRoutine))
#define NewWaitNextEventProc(userRoutine)			((WaitNextEventProcUPP)(userRoutine))
#define NewWaitNextEventPrePatch(userRoutine)		((WaitNextEventPrePatchUPP)(userRoutine))
#define NewWaitNextEventPostPatch(userRoutine)		((WaitNextEventPostPatchUPP)(userRoutine))
#endif

#if GENERATINGCFM
#define CallCleanUpApplicationPatch(userRoutine)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppCleanUpApplicationPatchProcInfo)
#define CallCloseWindowProc(userRoutine,window)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppCloseWindowProcInfo,(window))
#define CallCloseWindowPatch(userRoutine,window,proc)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppCloseWindowPatchProcInfo,(window),(proc))
#define CallDMFinalInitPatch(userRoutine)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppDMFinalInitPatchProcInfo)
#define CallDisposeWindowProc(userRoutine,window)								CallUniversalProc((UniversalProcPtr)(userRoutine),uppDisposeWindowProcInfo,(window))
#define CallDisposeWindowPatch(userRoutine,window,proc)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppDisposeWindowPatchProcInfo,(window),(proc))
#define CallDragGrayRgnLWProc(userRoutine,rgn,start,limit,slop,axis,action)		CallUniversalProc((UniversalProcPtr)(userRoutine),uppDragGrayRgnLWProcInfo,(rgn),(start),(limit),(slop),(axis),(action))
#define CallDragGrayRgnPatch(userRoutine,rgn,start,limit,slop,axis,action,proc)	CallUniversalProc((UniversalProcPtr)(userRoutine),uppDragGrayRgnPatchProcInfo,(rgn),(start),(limit),(slop),(axis),(action),(proc))
#define CallDragWindowProc(userRoutine,window,start,limit)						CallUniversalProc((UniversalProcPtr)(userRoutine),uppDragWindowProcInfo,(window),(start),(limit))
#define CallDragWindowPatch(userRoutine,window,start,limit,proc)				CallUniversalProc((UniversalProcPtr)(userRoutine),uppDragWindowPatchProcInfo,(window),(start),(limit),(proc))
#define CallFindSystemWindowPatch(userRoutine,where,window,result)				CallUniversalProc((UniversalProcPtr)(userRoutine),uppFindSystemWindowPatchProcInfo,(where),(window),(result))
#define CallFindWindowProc(userRoutine,where,window)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppFindWindowProcInfo,(where),(window))
#define CallFindWindowPatch(userRoutine,where,window,proc)						CallUniversalProc((UniversalProcPtr)(userRoutine),uppFindWindowPatchProcInfo,(where),(window),(proc))
#define CallFrameRgnProc(userRoutine,rgn)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppFrameRgnProcInfo,(rgn))
#define CallFrameRgnPatch(userRoutine,rgn,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppFrameRgnPatchProcInfo,(rgn),(proc))
#define CallGetMouseProc(userRoutine,mouseLoc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppGetMouseProcInfo,(mouseLoc))
#define CallGetMousePatch(userRoutine,mouseLoc,proc)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppGetMousePatchProcInfo,(mouseLoc),(proc))
#define CallInitApplicationPatch(userRoutine)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppInitApplicationPatchProcInfo)
#define CallMenuSelectProc(userRoutine,startPt)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppMenuSelectProcInfo,(startPt))
#define CallMenuSelectPatch(userRoutine,startPt,proc)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppMenuSelectPatchProcInfo,(startPt),(proc))
#define CallPaintRgnProc(userRoutine,rgn)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppPaintRgnProcInfo,(rgn))
#define CallPaintRgnPatch(userRoutine,rgn,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppPaintRgnPatchProcInfo,(rgn),(proc))
#define CallPostEventPatch(userRoutine,num,msg)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppPostEventPatchProcInfo,(num),(msg))
#define CallStillDownProc(userRoutine)											CallUniversalProc((UniversalProcPtr)(userRoutine),uppStillDownProcInfo)
#define CallStillDownPatch(userRoutine,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppStillDownPatchProcInfo,(proc))
#define CallSynchIdleTimePatch(userRoutine)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppSynchIdleTimePatchProcInfo)
#define CallSysWindowHandlerProc(userRoutine,window,event,part,handled)			CallUniversalProc((UniversalProcPtr)(userRoutine),uppSysWindowHandlerProcInfo,(window),(event),(part),(handled))
#define CallTrackGoAwayProc(userRoutine,window,where)							CallUniversalProc((UniversalProcPtr)(userRoutine),uppTrackGoAwayProcInfo,(window),(where))
#define CallTrackGoAwayPatch(userRoutine,window,where,proc)						CallUniversalProc((UniversalProcPtr)(userRoutine),uppTrackGoAwayPatchProcInfo,(window),(where),(proc))
#define CallVBLPatch(userRoutine)												CallUniversalProc((UniversalProcPtr)(userRoutine),uppVBLPatchProcInfo)
#define CallWaitMouseUpProc(userRoutine)										CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitMouseUpProcInfo)
#define CallWaitMouseUpPatch(userRoutine,proc)									CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitMouseUpPatchProcInfo,(proc))
#define CallWaitNextEventProc(userRoutine,mask,event,sleep,mouse)				CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitNextEventProcInfo,(mask),(event),(sleep),(mouse))
#define CallWaitNextEventPrePatch(userRoutine,mask,event,sleep,mouse)			CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitNextEventPrePatchProcInfo,(mask),(event),(sleep),(mouse))
#define CallWaitNextEventPostPatch(userRoutine,mask,event,sleep,mouse,result)	CallUniversalProc((UniversalProcPtr)(userRoutine),uppWaitNextEventPostPatchProcInfo,(mask),(event),(sleep),(mouse),(result))
#else
#define CallCleanUpApplicationPatch(userRoutine)								(*(CleanUpApplicationPatchPtr)(userRoutine))()
#define CallCloseWindowProc(userRoutine,window)									(*(CloseWindowProcPtr)(userRoutine))((window))
#define CallCloseWindowPatch(userRoutine,window,proc)							(*(CloseWindowPatchPtr)(userRoutine))((window),(proc))
#define CallDMFinalInitPatch(userRoutine)										(*(DMFinalInitPatchPtr)(userRoutine))()
#define CallDisposeWindowProc(userRoutine,window)								(*(DisposeWindowProcPtr)(userRoutine))((window))
#define CallDisposeWindowPatch(userRoutine,window,proc)							(*(DisposeWindowPatchPtr)(userRoutine))((window),(proc))
#define CallDragGrayRgnLWProc(userRoutine,rgn,start,limit,slop,axis,action)		(*(DragGrayRgnLWProcPtr)(userRoutine))((rgn),(start),(limit),(slop),(axis),(action))
#define CallDragGrayRgnPatch(userRoutine,rgn,start,limit,slop,axis,action,proc)	(*(DragGrayRgnPatchPtr)(userRoutine))((rgn),(start),(limit),(slop),(axis),(action),(proc))
#define CallDragWindowProc(userRoutine,window,start,limit)						(*(DragWindowProcPtr)(userRoutine))((window),(start),(limit))
#define CallDragWindowPatch(userRoutine,window,start,limit,proc)				(*(DragWindowPatchPtr)(userRoutine))((window),(start),(limit),(proc))
#define CallFindSystemWindowPatch(userRoutine,where,window,result)				(*(FindSystemWindowPatchPtr)(userRoutine))((where),(window),(result))
#define CallFindWindowProc(userRoutine,where,window)							(*(FindWindowProcPtr)(userRoutine))((where),(window))
#define CallFindWindowPatch(userRoutine,where,window,proc)						(*(FindWindowPatchPtr)(userRoutine))((where),(window),(proc))
#define CallFrameRgnProc(userRoutine,rgn)										(*(FrameRgnProcPtr)(userRoutine))((rgn))
#define CallFrameRgnPatch(userRoutine,rgn,proc)									(*(FrameRgnPatchPtr)(userRoutine))((rgn),(proc))
#define CallGetMouseProc(userRoutine,mouseLoc)									(*(GetMouseProcPtr)(userRoutine))((mouseLoc))
#define CallGetMousePatch(userRoutine,mouseLoc,proc)							(*(GetMousePatchPtr)(userRoutine))((mouseLoc),(proc))
#define CallInitApplicationPatch(userRoutine)									(*(InitApplicationPatchPtr)(userRoutine))()
#define CallMenuSelectProc(userRoutine,startPt)									(*(MenuSelectProcPtr)(userRoutine))((startPt))
#define CallMenuSelectPatch(userRoutine,startPt,proc)							(*(MenuSelectPatchPtr)(userRoutine))((startPt),(proc))
#define CallPaintRgnProc(userRoutine,rgn)										(*(PaintRgnProcPtr)(userRoutine))((rgn))
#define CallPaintRgnPatch(userRoutine,rgn,proc)									(*(PaintRgnPatchPtr)(userRoutine))((rgn),(proc))
#define CallPostEventPatch(userRoutine,num,msg)									(*(PostEventPatchPtr)(userRoutine))((num),(msg))
#define CallStillDownProc(userRoutine)											(*(StillDownProcPtr)(userRoutine))()
#define CallStillDownPatch(userRoutine,proc)									(*(StillDownPatchPtr)(userRoutine))((proc))
#define CallSynchIdleTimePatch(userRoutine)										(*(SynchIdleTimePatchPtr)(userRoutine))()
#define CallSysWindowHandlerProc(userRoutine,window,event,part,handled)			(*(SysWindowHandlerProcPtr)(userRoutine))((window),(event),(part),(handled))
#define CallTrackGoAwayProc(userRoutine,window,where)							(*(TrackGoAwayProcPtr)(userRoutine))((window),(where))
#define CallTrackGoAwayPatch(userRoutine,window,where,proc)						(*(TrackGoAwayPatchPtr)(userRoutine))((window),(where),(proc))
#define CallVBLPatch(userRoutine)												(*(VBLPatchPtr)(userRoutine))()
#define CallWaitMouseUpProc(userRoutine)										(*(WaitMouseUpProcPtr)(userRoutine))()
#define CallWaitMouseUpPatch(userRoutine,proc)									(*(WaitMouseUpPatchPtr)(userRoutine))((proc))
#define CallWaitNextEventProc(userRoutine,mask,event,sleep,mouse)				(*(WaitNextEventProcPtr)(userRoutine))((mask),(event),(sleep),(mouse))
#define CallWaitNextEventPrePatch(userRoutine,mask,event,sleep,mouse)			(*(WaitNextEventPrePatchPtr)(userRoutine))((mask),(event),(sleep),(mouse))
#define CallWaitNextEventPostPatch(userRoutine,mask,event,sleep,mouse,result)	(*(WaitNextEventPostPatchPtr)(userRoutine))((mask),(event),(sleep),(mouse),(result))
#endif


#endif /* _PROCINFO_ */
