#ifndef _EVENT_
#define _EVENT_

#include <AppleEvents.h>
#include <Events.h>
#include <MacTypes.h>

typedef class EventManager
{
	public:
		virtual void DoDispatch(EventRecord *event) = 0;
} EventManager;


typedef class BaseEventManager : public EventManager
{
	public:
		virtual void DoDispatch(EventRecord *event);
		
		virtual void HandleNullEventDispatch(EventRecord *event);
		virtual void HandleMouseDownDispatch(EventRecord *event);
		virtual void HandleMouseUpDispatch(EventRecord *event);
		virtual void HandleKeyDownDispatch(EventRecord *event);
		virtual void HandleKeyUpDispatch(EventRecord *event);
		virtual void HandleAutoKeyDispatch(EventRecord *event);
		virtual void HandleUpdateEvtDispatch(EventRecord *event);
		virtual void HandleActivateEvtDispatch(EventRecord *event);
		virtual void HandleOSEvtDispatch(EventRecord *event);
		virtual void HandleHighLevelEventDispatch(EventRecord *event);
		virtual void HandleDialogEventDispatch(EventRecord *event);
		virtual void HandleInMenuBarDispatch(EventRecord *event);
} BaseEventManager;


#ifdef __cplusplus
extern "C" {
#endif


void InitAppleEvents(void);
void ProcessAppleEvent(EventRecord *event);


#ifdef __cplusplus
}
#endif

#endif /* _EVENT_ */
